/////////////////////////////////////////////////////////////////////////////
//		CPageExe.cpp
#include	<windows.h>
#include	<shlobj.h>
#include	"util.h"
#include	"ShInf.h"
#include	"resource.h"


/////////////////////////////////////////////////////////
//	쐬Ej

//RXgN^
CPageExe::CPageExe()
{
//	ZeroMemory( &m_doshdr, sizeof(IMAGE_DOS_HEADER) );
//	ZeroMemory( &m_nthdr, sizeof(IMAGE_NT_HEADERS) );
//	m_sechdr_num = 0;
	m_sechdr_ary = NULL;
	m_impsec     = NULL;
	m_expsec     = NULL;
}

//fXgN^
CPageExe::~CPageExe()
{
//	ZeroMemory( &m_doshdr, sizeof(IMAGE_DOS_HEADER) );
//	ZeroMemory( &m_nthdr, sizeof(IMAGE_NT_HEADERS) );
	if( m_sechdr_ary )	delete [] m_sechdr_ary;
	if( m_impsec     )	delete [] m_impsec;
	if( m_expsec     )	delete [] m_expsec;
}


/////////////////////////////////////////////////////////
//	֐

//y[W^Cg̎擾
LPCTSTR CPageExe::GetDlgTitle()
{
	return	_T("swb_");
}

//y[Wev[g̎擾
LPCTSTR CPageExe::GetDlgTemplate()
{
	return	MAKEINTRESOURCE(IDD_DLGPE);
}

//t@C̃`FbN & wb_̓ǂݍ
BOOL CPageExe::CheckFile( LPCTSTR szFile )
{
	BOOL				Result = FALSE;
	WORD				n;
	HANDLE				hFile;
	SECURITY_ATTRIBUTES	sa;
	DWORD				dwRead;
	DWORD				dwOffset;
	DWORD				dwSize;

	//t@CJ
	ZeroMemory( &sa, sizeof(SECURITY_ATTRIBUTES) );
	sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	hFile = CreateFile(szFile,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,&sa,OPEN_EXISTING,0,NULL);
	if( hFile == INVALID_HANDLE_VALUE )
		goto CheckFile_Exit;

	//DOSwb_
	dwOffset = 0;
	SetFilePointer( hFile, dwOffset, NULL, FILE_BEGIN );
	if( !ReadFile(hFile,&m_doshdr,sizeof(IMAGE_DOS_HEADER),&dwRead,NULL) )
		goto CheckFile_Exit;
	//`FbN
	if( m_doshdr.e_magic != IMAGE_DOS_SIGNATURE )
		goto CheckFile_Exit;
	if( m_doshdr.e_cparhdr < (sizeof(IMAGE_DOS_HEADER) + 0x0F) >> 4 )
		goto CheckFile_Exit;

	//PEwb_
	dwOffset = m_doshdr.e_lfanew;
	SetFilePointer( hFile, dwOffset, NULL, FILE_BEGIN );
	if( !ReadFile(hFile,&m_nthdr,sizeof(IMAGE_NT_HEADERS),&dwRead,NULL) )
		goto CheckFile_Exit;
	//`FbN
	if( m_nthdr.Signature != IMAGE_NT_SIGNATURE )
		goto CheckFile_Exit;
	if( !(m_nthdr.FileHeader.Characteristics & IMAGE_FILE_32BIT_MACHINE)
	||	!(m_nthdr.FileHeader.Characteristics & IMAGE_FILE_EXECUTABLE_IMAGE) )
		goto CheckFile_Exit;
	if( m_nthdr.OptionalHeader.Magic != IMAGE_NT_OPTIONAL_HDR_MAGIC )
		goto CheckFile_Exit;

	//SECwb_
	m_sechdr_num = m_nthdr.FileHeader.NumberOfSections;
	m_sechdr_ary = new IMAGE_SECTION_HEADER[m_sechdr_num];
	dwOffset = m_doshdr.e_lfanew + sizeof(DWORD) + sizeof(IMAGE_FILE_HEADER) + m_nthdr.FileHeader.SizeOfOptionalHeader;
	dwSize   = IMAGE_SIZEOF_SECTION_HEADER * m_sechdr_num;
	SetFilePointer( hFile, dwOffset, NULL, FILE_BEGIN );
	if( !ReadFile(hFile,m_sechdr_ary,dwSize,&dwRead,NULL) )
		goto CheckFile_Exit;

	//ImportZNV
	if( m_nthdr.OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress )
	for( n=m_sechdr_num-1; n>=0; --n ){
		if( m_nthdr.OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress
		  < m_sechdr_ary[n].VirtualAddress )
				continue;

		dwOffset = m_sechdr_ary[n].PointerToRawData;
//		dwSize   = m_sechdr_ary[n].Misc.VirtualSize;
		dwSize   = ( n==m_sechdr_num-1 ? GetFileSize(hFile,NULL) : m_sechdr_ary[n+1].PointerToRawData )
				 - m_sechdr_ary[n].PointerToRawData;

		m_impsec = new CHAR[dwSize];
		m_impsec_addr = m_sechdr_ary[n].VirtualAddress;
		SetFilePointer( hFile, dwOffset, NULL, FILE_BEGIN );
		if( !ReadFile(hFile,m_impsec,dwSize,&dwRead,NULL) )
			goto CheckFile_Exit;

		break;
	}

	//ExportZNV
	if( m_nthdr.OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress )
	for( n=m_sechdr_num-1; n>=0; --n ){
		if( m_nthdr.OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress
		  < m_sechdr_ary[n].VirtualAddress )
				continue;

		dwOffset = m_sechdr_ary[n].PointerToRawData;
//		dwSize   = m_sechdr_ary[n].Misc.VirtualSize;
		dwSize   = ( n==m_sechdr_num-1 ? GetFileSize(hFile,NULL) : m_sechdr_ary[n+1].PointerToRawData )
				 - m_sechdr_ary[n].PointerToRawData;

		m_expsec = new CHAR[dwSize];
		m_expsec_addr = m_sechdr_ary[n].VirtualAddress;
		SetFilePointer( hFile, dwOffset, NULL, FILE_BEGIN );
		if( !ReadFile(hFile,m_expsec,dwSize,&dwRead,NULL) )
			goto CheckFile_Exit;

		break;
	}

	Result = TRUE;

CheckFile_Exit:
	if( hFile != INVALID_HANDLE_VALUE )	CloseHandle(hFile);
	return	Result;
}

//y[W̏
BOOL CPageExe::OnInitDialog( HWND hWnd, HWND hWndFocus, LPARAM lParam )
{
	SendMessage( GetDlgItem(hWnd,IDC_CMBTYPE), CB_ADDSTRING, 0, (LPARAM)_T("DOSwb_") );
	OnInitDOS( GetDlgItem(hWnd,IDC_LSTDOS) );

	SendMessage( GetDlgItem(hWnd,IDC_CMBTYPE), CB_ADDSTRING, 0, (LPARAM)_T("PEwb_") );
	OnInitPE( GetDlgItem(hWnd,IDC_LSTPEH) );

	SendMessage( GetDlgItem(hWnd,IDC_CMBTYPE), CB_ADDSTRING, 0, (LPARAM)_T("ZNV") );
	OnInitSection( GetDlgItem(hWnd,IDC_LSTSEC) );

	SendMessage( GetDlgItem(hWnd,IDC_CMBTYPE), CB_ADDSTRING, 0, (LPARAM)_T("fBNg") );
	OnInitDirectory( GetDlgItem(hWnd,IDC_LSTDIR) );

	if( m_impsec ){
		SendMessage( GetDlgItem(hWnd,IDC_CMBTYPE), CB_ADDSTRING, 0, (LPARAM)_T("C|[g") );
		OnInitImport( GetDlgItem(hWnd,IDC_LSTIMP) );
	}
	if( m_expsec ){
		SendMessage( GetDlgItem(hWnd,IDC_CMBTYPE), CB_ADDSTRING, 0, (LPARAM)_T("GNX|[g") );
		OnInitExport( GetDlgItem(hWnd,IDC_LSTEXP) );
	}

	SendMessage( GetDlgItem(hWnd,IDC_CMBTYPE), CB_SETCURSEL, 0, 0 );

	return	TRUE;
}
//ListView̏p
LPCTSTR	HEX4=_T("%04X"), HEX8=_T("%08X"), ADDR=_T("%04X:%04X"), VERS=_T("%d.%d");
#ifdef _UNICODE
#define ToUnicode(_S,_B) {MultiByteToWideChar(CP_ACP,0,(LPCSTR)_S,-1,_B,256);}
#else
#define ToUnicode(_S,_B) {lstrcpy(_B,(LPCTSTR)_S);}
#endif
#define InsColm(_I,_T,_L) {lvCol.pszText=_T;lvCol.cx=_L;SendMessage(hWndCtl,LVM_INSERTCOLUMN,_I,(LPARAM)&lvCol);}
#define InsItem(_I,_M) {lvItm.iItem=_I;lvItm.iSubItem=0;lvItm.pszText=_M;lvItm.cchTextMax=lstrlen(_M);SendMessage(hWndCtl,LVM_INSERTITEM,0,(LPARAM)&lvItm);}
#define InsItemFmt1(_I,_F,_V) {wsprintf(szMsg,_F,_V);InsItem(_I,szMsg);}
#define SetItem(_S,_M) {lvItm.iSubItem=_S;lvItm.pszText=_M;lvItm.cchTextMax=lstrlen(_M);SendMessage(hWndCtl,LVM_SETITEM,0,(LPARAM)&lvItm);}
#define SetItemFmt1(_S,_F,_V) {wsprintf(szMsg,_F,_V);SetItem(_S,szMsg);}
#define SetItemFmt2(_S,_F,_V1,_V2) {wsprintf(szMsg,_F,_V1,_V2);SetItem(_S,szMsg);}
#define FHCFlg0(_F,_V) {if(!(m_nthdr.FileHeader.Characteristics & _F)) lstrcat(szMsg,_T(", ")_V);}
#define FHCFlg1(_F,_V) {if(m_nthdr.FileHeader.Characteristics & _F) lstrcat(szMsg,_T(", ")_V);}
#define FHCFlg2(_F,_V1,_V2) {lstrcat(szMsg, (m_nthdr.FileHeader.Characteristics & _F) ? _T(", ")_V1 : _T(", ")_V2);}
#define SECFlg(_F,_V) {if(m_sechdr_ary[nCnt].Characteristics & _F) lstrcat(szMsg,_T(", ")_V);}
//DOSwb_
BOOL CPageExe::OnInitDOS( HWND hWndCtl )
{
	LV_COLUMN	lvCol;
	LV_ITEM		lvItm;
	TCHAR		szMsg[256];

	SendMessage( hWndCtl, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_FULLROWSELECT );

	//^Cg̐ݒ
	ZeroMemory( &lvCol, sizeof(LV_COLUMN) );
	lvCol.mask	= LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	lvCol.fmt	= LVCFMT_LEFT;
	InsColm( 0, _T("Name") , 151 );
	InsColm( 1, _T("Value"), 200 );

	//e̐ݒ
	ZeroMemory( &lvCol, sizeof(LV_COLUMN) );
	lvItm.mask	= LVIF_TEXT;
	InsItem( 0,_T("Magic number"));				SetItemFmt1(1,HEX4,m_doshdr.e_magic);
	InsItem( 1,_T("Last page size [byte]"));	SetItemFmt1(1,HEX4,m_doshdr.e_cblp);
	InsItem( 2,_T("All pages"));				SetItemFmt1(1,HEX4,m_doshdr.e_cp);
	InsItem( 3,_T("Relocation entries"));		SetItemFmt1(1,HEX4,m_doshdr.e_crlc);
	InsItem( 4,_T("Header size [para]"));		SetItemFmt1(1,HEX4,m_doshdr.e_cparhdr);
	InsItem( 5,_T("Min extra memory [para]"));	SetItemFmt1(1,HEX4,m_doshdr.e_minalloc);
	InsItem( 6,_T("Max extra memory [para]"));	SetItemFmt1(1,HEX4,m_doshdr.e_maxalloc);
	InsItem( 7,_T("Stack address"));			SetItemFmt2(1,ADDR,m_doshdr.e_ss,m_doshdr.e_sp);
	InsItem( 8,_T("Check sum 16"));				SetItemFmt1(1,HEX4,m_doshdr.e_csum);
	InsItem( 9,_T("Start address"));			SetItemFmt2(1,ADDR,m_doshdr.e_cs,m_doshdr.e_ip);
	InsItem(10,_T("Relocation table address"));	SetItemFmt1(1,HEX4,m_doshdr.e_lfarlc);
	InsItem(11,_T("Overlay No."));				SetItemFmt1(1,HEX4,m_doshdr.e_ovno);
	InsItem(12,_T("OEM ID:info"));				SetItemFmt2(1,ADDR,m_doshdr.e_oemid,m_doshdr.e_oeminfo);
	InsItem(13,_T("New header address"));		SetItemFmt1(1,HEX8,m_doshdr.e_lfanew);

	return	TRUE;
}
//PEwb_
BOOL CPageExe::OnInitPE( HWND hWndCtl )
{
	LV_COLUMN	lvCol;
	LV_ITEM		lvItm;
	TCHAR		szMsg[256];

	SendMessage( hWndCtl, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_FULLROWSELECT );

	//^Cg̐ݒ
	ZeroMemory( &lvCol, sizeof(LV_COLUMN) );
	lvCol.mask	= LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	lvCol.fmt	= LVCFMT_LEFT;
	InsColm( 0, _T("Name") , 151 );
	InsColm( 1, _T("Value"), 200 );

	//e̐ݒ
	ZeroMemory( &lvCol, sizeof(LV_COLUMN) );
	lvItm.mask	= LVIF_TEXT;
	InsItem( 0,_T("Target CPU type"));			switch( m_nthdr.FileHeader.Machine ){
												case IMAGE_FILE_MACHINE_I386:	SetItem(1,_T("x86"));		break;
												case IMAGE_FILE_MACHINE_R3000:	SetItem(1,_T("R3000"));		break;
												case IMAGE_FILE_MACHINE_R4000:	SetItem(1,_T("R4000"));		break;
												case IMAGE_FILE_MACHINE_R10000:	SetItem(1,_T("R10000"));	break;
												case IMAGE_FILE_MACHINE_ALPHA:	SetItem(1,_T("ALPHA"));		break;
												case IMAGE_FILE_MACHINE_POWERPC:SetItem(1,_T("Power PC"));	break;
												default:						SetItem(1,_T("unknown"));	break;	}
	InsItem( 1,_T("Section No."));				SetItemFmt1(1,HEX4,m_nthdr.FileHeader.NumberOfSections);
	InsItem( 2,_T("Link time stamp"));			SetItemFmt1(1,HEX8,m_nthdr.FileHeader.TimeDateStamp);	//"%04d/%02d/%02d %02d:%02d:%02d (%08x)"
	InsItem( 3,_T("Symbol table file offset"));	SetItemFmt1(1,HEX8,m_nthdr.FileHeader.PointerToSymbolTable);
	InsItem( 4,_T("Symbol No."));				SetItemFmt1(1,HEX8,m_nthdr.FileHeader.NumberOfSymbols);
	InsItem( 5,_T("Optional header size"));		SetItemFmt1(1,HEX4,m_nthdr.FileHeader.SizeOfOptionalHeader);
	lstrcpy(szMsg,_T(""));
	FHCFlg1( IMAGE_FILE_BYTES_REVERSED_HI,			_T("HiBytesReversed") );
	FHCFlg1( IMAGE_FILE_UP_SYSTEM_ONLY,				_T("UpSystemOnly") );
	FHCFlg1( IMAGE_FILE_DLL,						_T("DLL") );
	FHCFlg1( IMAGE_FILE_SYSTEM,						_T("System") );
	FHCFlg1( IMAGE_FILE_NET_RUN_FROM_SWAP,			_T("NetRunFromSwap") );
	FHCFlg1( IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP,	_T("RemovableRunFromSwap") );
	FHCFlg1( IMAGE_FILE_DEBUG_STRIPPED,				_T("Debug") );
	FHCFlg2( IMAGE_FILE_32BIT_MACHINE,				_T("32-bit"), _T("16-bit") );
	FHCFlg1( IMAGE_FILE_BYTES_REVERSED_LO,			_T("LoBytesReversed") );
	FHCFlg1( IMAGE_FILE_AGGRESIVE_WS_TRIM,			_T("AggresiveWsTrim") );
	FHCFlg0( IMAGE_FILE_LOCAL_SYMS_STRIPPED,		_T("Symbol") );
	FHCFlg0( IMAGE_FILE_LINE_NUMS_STRIPPED,			_T("LineNo") );
	FHCFlg2( IMAGE_FILE_EXECUTABLE_IMAGE,			_T("Executable"), _T("NonExecutable") );
	FHCFlg2( IMAGE_FILE_RELOCS_STRIPPED,			_T("NonRelocationsInfo"), _T("RelocationsInfo") );
	InsItem( 6,_T("Flags"));					SetItem(1,szMsg+2);
	InsItem( 7,_T("Signeture"));				SetItemFmt1(1,HEX4,m_nthdr.OptionalHeader.Magic);
	InsItem( 8,_T("Linker version"));			SetItemFmt2(1,VERS,m_nthdr.OptionalHeader.MajorLinkerVersion,m_nthdr.OptionalHeader.MinorLinkerVersion);
	InsItem( 9,_T("Code section size"));		SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.SizeOfCode);
	InsItem(10,_T("Init.data section size"));	SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.SizeOfInitializedData);
	InsItem(11,_T("Uninit.data section size"));	SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.SizeOfUninitializedData);
	InsItem(12,_T("Start address"));			SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.ImageBase+m_nthdr.OptionalHeader.AddressOfEntryPoint);
	InsItem(13,_T("Code section base addr."));	SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.ImageBase+m_nthdr.OptionalHeader.BaseOfCode);
	InsItem(14,_T("Data section base addr."));	SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.ImageBase+m_nthdr.OptionalHeader.BaseOfData);
	InsItem(15,_T("Image base address"));		SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.ImageBase);
	InsItem(16,_T("Section alignment size"));	SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.SectionAlignment);
	InsItem(17,_T("File alignment size"));		SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.FileAlignment);
	InsItem(18,_T("Operation system version"));	SetItemFmt2(1,VERS,m_nthdr.OptionalHeader.MajorOperatingSystemVersion,m_nthdr.OptionalHeader.MinorOperatingSystemVersion);
	InsItem(19,_T("User defined version"));		SetItemFmt2(1,VERS,m_nthdr.OptionalHeader.MajorImageVersion,m_nthdr.OptionalHeader.MinorImageVersion);
	InsItem(20,_T("Sub-system version"));		SetItemFmt2(1,VERS,m_nthdr.OptionalHeader.MajorSubsystemVersion,m_nthdr.OptionalHeader.MinorSubsystemVersion);
	InsItem(21,_T("Reserved"));					SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.Win32VersionValue);
	InsItem(22,_T("Image size"));				SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.SizeOfImage);
	InsItem(23,_T("Headers size"));				SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.SizeOfHeaders);
	InsItem(24,_T("Check sum 32"));				SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.CheckSum);
	InsItem(25,_T("Sub-system"));				switch( m_nthdr.OptionalHeader.Subsystem ){
												case IMAGE_SUBSYSTEM_NATIVE:		SetItem(1,_T("Native"));		break;
												case IMAGE_SUBSYSTEM_WINDOWS_GUI:	SetItem(1,_T("Windows GUI"));	break;
												case IMAGE_SUBSYSTEM_WINDOWS_CUI:	SetItem(1,_T("Windows CUI"));	break;
												case IMAGE_SUBSYSTEM_OS2_CUI:		SetItem(1,_T("OS2 CUI"));		break;
												case IMAGE_SUBSYSTEM_POSIX_CUI:		SetItem(1,_T("POSIX CUI"));		break;
												default:							SetItem(1,_T("unknown"));		break;	}
	InsItem(26,_T("DLL init.func.flags"));		SetItemFmt1(1,HEX4,m_nthdr.OptionalHeader.DllCharacteristics);
	InsItem(27,_T("Reserved stack size"));		SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.SizeOfStackReserve);
	InsItem(28,_T("Commit stack size"));		SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.SizeOfStackCommit);
	InsItem(29,_T("Reserved heap size"));		SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.SizeOfHeapReserve);
	InsItem(30,_T("Commit heap size"));			SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.SizeOfHeapCommit);
	InsItem(31,_T("Loader flags"));				SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.LoaderFlags);
	InsItem(32,_T("Data directory No."));		SetItemFmt1(1,HEX8,m_nthdr.OptionalHeader.NumberOfRvaAndSizes);

	return	TRUE;
}
//SECwb_
BOOL CPageExe::OnInitSection( HWND hWndCtl )
{
	LV_COLUMN	lvCol;
	LV_ITEM		lvItm;
	TCHAR		szMsg[256];

	SendMessage( hWndCtl, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_FULLROWSELECT );

	//^Cg̐ݒ
	ZeroMemory( &lvCol, sizeof(LV_COLUMN) );
	lvCol.mask	= LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	lvCol.fmt	= LVCFMT_LEFT;
	InsColm( 0, _T("Section")  ,  72 );
	InsColm( 1, _T("Addr")     ,  72 );
	InsColm( 2, _T("Size")     ,  72 );
	InsColm( 3, _T("AlignSize"),  72 );
	InsColm( 4, _T("FileOff")  ,  72 );
	InsColm( 5, _T("RelocOff") ,  72 );
	InsColm( 6, _T("Lin#Off")  ,  72 );
	InsColm( 7, _T("Rel#")     ,  40 );
	InsColm( 8, _T("Lin#")     ,  40 );
	InsColm( 9, _T("Flags")    , 120 );

	//e̐ݒ
	SendMessage( hWndCtl, LVM_DELETEALLITEMS, 0, 0 );
	ZeroMemory( &lvCol, sizeof(LV_COLUMN) );
	lvItm.mask	= LVIF_TEXT;
	for( int nCnt=0; nCnt<m_nthdr.FileHeader.NumberOfSections; ++nCnt )
	{
		ToUnicode(m_sechdr_ary[nCnt].Name, szMsg);
		InsItem( nCnt, szMsg );
		SetItemFmt1( 1, HEX8, m_nthdr.OptionalHeader.ImageBase+m_sechdr_ary[nCnt].VirtualAddress );
		SetItemFmt1( 2, HEX8, m_sechdr_ary[nCnt].Misc.VirtualSize );
		SetItemFmt1( 3, HEX8, m_sechdr_ary[nCnt].SizeOfRawData );
		SetItemFmt1( 4, HEX8, m_sechdr_ary[nCnt].PointerToRawData );
		SetItemFmt1( 5, HEX8, m_sechdr_ary[nCnt].PointerToRelocations );
		SetItemFmt1( 6, HEX8, m_sechdr_ary[nCnt].PointerToLinenumbers );
		SetItemFmt1( 7, HEX4, m_sechdr_ary[nCnt].NumberOfRelocations );
		SetItemFmt1( 8, HEX4, m_sechdr_ary[nCnt].NumberOfLinenumbers );
		lstrcpy(szMsg,_T(""));
		SECFlg( IMAGE_SCN_MEM_WRITE, _T("Write") );
		SECFlg( IMAGE_SCN_MEM_READ, _T("Read") );
		SECFlg( IMAGE_SCN_MEM_EXECUTE, _T("Execute") );
		SECFlg( IMAGE_SCN_MEM_SHARED, _T("Shared") );
		SECFlg( IMAGE_SCN_MEM_NOT_PAGED, _T("NotPaged") );
		SECFlg( IMAGE_SCN_MEM_NOT_CACHED, _T("NotCached") );
		SECFlg( IMAGE_SCN_MEM_DISCARDABLE, _T("Discardable") );
		SECFlg( IMAGE_SCN_LNK_NRELOC_OVFL, _T("Ext.Reloc.") );
		SECFlg( IMAGE_SCN_MEM_PRELOAD, _T("Preload") );
		SECFlg( IMAGE_SCN_MEM_LOCKED, _T("Locked") );
		SECFlg( IMAGE_SCN_MEM_PURGEABLE, _T("Purgeable") );
		SECFlg( IMAGE_SCN_MEM_FARDATA, _T("FarData") );
		SECFlg( IMAGE_SCN_LNK_COMDAT, _T("ComDat") );
		SECFlg( IMAGE_SCN_LNK_REMOVE, _T("Remove") );
		SECFlg( IMAGE_SCN_LNK_INFO, _T("Info") );
		SECFlg( IMAGE_SCN_LNK_OTHER, _T("Other") );
		SECFlg( IMAGE_SCN_CNT_UNINITIALIZED_DATA, _T("Uninit.Data") );
		SECFlg( IMAGE_SCN_CNT_INITIALIZED_DATA, _T("Init.Data") );
		SECFlg( IMAGE_SCN_CNT_CODE, _T("Code") );
		SECFlg( IMAGE_SCN_TYPE_NO_PAD, _T("NoPad") );
		SetItem(9,szMsg+2);
	}

	return	TRUE;
}
//fBNg
BOOL CPageExe::OnInitDirectory( HWND hWndCtl )
{
	LV_COLUMN	lvCol;
	LV_ITEM		lvItm;
	TCHAR		szMsg[256];
	LPTSTR		szDirName[]={
		_T("Export"),_T("Import"),_T("Resource"),_T("Exception"),_T("Security"),_T("BaseReloc"),_T("Debug"),_T("CopyRight"),
		_T("GlobalPtr"),_T("TLS"),_T("Ld.Config"),_T("BoundImp"),_T("ImpAdrTbl"),_T("#0000000d"),_T("#0000000e"),_T("#0000000f")};

	SendMessage( hWndCtl, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_FULLROWSELECT );

	//^Cg̐ݒ
	ZeroMemory( &lvCol, sizeof(LV_COLUMN) );
	lvCol.mask	= LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	lvCol.fmt	= LVCFMT_LEFT;
	InsColm( 0, _T("Name"), 72 );
	InsColm( 1, _T("Addr"), 72 );
	InsColm( 2, _T("Size"), 72 );

	//e̐ݒ
	ZeroMemory( &lvCol, sizeof(LV_COLUMN) );
	lvItm.mask	= LVIF_TEXT;
	for( DWORD nCnt=0; nCnt<m_nthdr.OptionalHeader.NumberOfRvaAndSizes; ++nCnt )
	{
		InsItem( nCnt, szDirName[nCnt] );
		DWORD dwAddr = m_nthdr.OptionalHeader.DataDirectory[nCnt].VirtualAddress;
		if( dwAddr )	dwAddr += m_nthdr.OptionalHeader.ImageBase;
		SetItemFmt1( 1, HEX8, dwAddr );
		SetItemFmt1( 2, HEX8, m_nthdr.OptionalHeader.DataDirectory[nCnt].Size );
	}

	return	TRUE;
}
//C|[g
BOOL CPageExe::OnInitImport( HWND hWndCtl )
{
	LV_COLUMN	lvCol;
	LV_ITEM		lvItm;
	TCHAR		szMsg[256];
	TCHAR		szMsg2[256];
	TCHAR		szMsg3[256];

	SendMessage( hWndCtl, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_FULLROWSELECT );

	//^Cg̐ݒ
	ZeroMemory( &lvCol, sizeof(LV_COLUMN) );
	lvCol.mask	= LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	lvCol.fmt	= LVCFMT_LEFT;
	InsColm( 0, _T("Server"),  82 );
	InsColm( 1, _T("Ord")   ,  48 );
	InsColm( 2, _T("Name")  , 221 );

	//e̐ݒ
	ZeroMemory( &lvCol, sizeof(LV_COLUMN) );
	lvItm.mask	= LVIF_TEXT;
	int nCount	= 0;
	LPTSTR szName;
	PIMAGE_IMPORT_DESCRIPTOR pImpDesc = (PIMAGE_IMPORT_DESCRIPTOR)(&m_impsec[m_nthdr.OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress - m_impsec_addr]);
	for( int nDesc=0; pImpDesc[nDesc].Characteristics; ++nDesc )
	{
		ToUnicode(&m_impsec[pImpDesc[nDesc].Name - m_impsec_addr], szMsg2);
		LPTSTR szServer = szMsg2;
		PIMAGE_THUNK_DATA pThkDat = (PIMAGE_THUNK_DATA)(&m_impsec[(DWORD)(pImpDesc[nDesc].OriginalFirstThunk) - m_impsec_addr]);
		DWORD dwOrdinal;
		for( int nThunk=0; dwOrdinal=pThkDat[nThunk].u1.Ordinal; ++nThunk )
		{
			if( IMAGE_SNAP_BY_ORDINAL(dwOrdinal) )	// 0x80000000 ... 0xFFFFFFFF
			{
				dwOrdinal	= IMAGE_ORDINAL(dwOrdinal);
				szName		= _T("<unknown name>");
			}
			else									// 0x00000000 ... 0x7FFFFFFF
			{
				PIMAGE_IMPORT_BY_NAME pImpName = (PIMAGE_IMPORT_BY_NAME)(&m_impsec[dwOrdinal - m_impsec_addr]);
				ToUnicode(pImpName->Name, szMsg3);
				dwOrdinal	= pImpName->Hint;
				szName		= szMsg3;
			}
			InsItem( nCount++, szServer );
			SetItemFmt1( 1, HEX4, dwOrdinal );
			SetItem( 2, szName );
		}
	}

	return	TRUE;
}
//GNX|[g
BOOL CPageExe::OnInitExport( HWND hWndCtl )
{
	LV_COLUMN	lvCol;
	LV_ITEM		lvItm;
	TCHAR		szMsg[256];

	SendMessage( hWndCtl, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_FULLROWSELECT );

	//^Cg̐ݒ
	ZeroMemory( &lvCol, sizeof(LV_COLUMN) );
	lvCol.mask	= LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	lvCol.fmt	= LVCFMT_LEFT;
	InsColm( 0, _T("Ord") ,  40 );
	InsColm( 1, _T("Name"), 311 );

	//e̐ݒ
	try {
		ZeroMemory( &lvCol, sizeof(LV_COLUMN) );
		lvItm.mask	= LVIF_TEXT;
		PIMAGE_EXPORT_DIRECTORY pExpDir = (PIMAGE_EXPORT_DIRECTORY)(&m_expsec[m_nthdr.OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress - m_expsec_addr]);
		WORD  *wOrdTable   = (WORD* )(&m_expsec[(DWORD)(pExpDir->AddressOfNameOrdinals) - m_expsec_addr]);
		DWORD *dwNameTable = (DWORD*)(&m_expsec[(DWORD)(pExpDir->AddressOfNames       ) - m_expsec_addr]);
		for( DWORD nCnt=0; nCnt < pExpDir->NumberOfNames; ++nCnt )
		{
			InsItemFmt1( nCnt, HEX4, wOrdTable[nCnt] + pExpDir->Base );
			ToUnicode( &m_expsec[dwNameTable[nCnt] - m_expsec_addr], szMsg);
			SetItem( 1, szMsg );
		}
	
		return	TRUE;
	}
	catch(...) {
		return	FALSE;
	}
}

//y[W̔j
BOOL CPageExe::OnDestory( HWND hWnd )
{
	return	TRUE;
}

//y[W̓Kp
BOOL CPageExe::OnNofity( HWND hWnd, int idCtrl, LPNMHDR pnmh )
{
	return	FALSE;
}

//y[W̃R}h
BOOL CPageExe::OnCommand( HWND hWnd, int id, HWND hWndCtl, UINT code )
{
	switch( id ){
	case IDC_CMBTYPE:
		if( code!=CBN_SELCHANGE )
			break;
		{
		int i=SendMessage(hWndCtl,CB_GETCURSEL,0,0);
						ShowWindow( GetDlgItem(hWnd,IDC_LSTDOS), i-- ? SW_HIDE:SW_SHOW );
						ShowWindow( GetDlgItem(hWnd,IDC_LSTPEH), i-- ? SW_HIDE:SW_SHOW );
						ShowWindow( GetDlgItem(hWnd,IDC_LSTSEC), i-- ? SW_HIDE:SW_SHOW );
						ShowWindow( GetDlgItem(hWnd,IDC_LSTDIR), i-- ? SW_HIDE:SW_SHOW );
		if( m_impsec )	ShowWindow( GetDlgItem(hWnd,IDC_LSTIMP), i-- ? SW_HIDE:SW_SHOW );
		if( m_expsec )	ShowWindow( GetDlgItem(hWnd,IDC_LSTEXP), i-- ? SW_HIDE:SW_SHOW );
		}
		return	TRUE;
	}

	return	FALSE;
}
